Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | ENUM CONSTANTS | FIELD | METHOD | DETAIL: ENUM CONSTANTS | FIELD | METHOD

## org.apache.hadoop.fs
Enum CreateFlag

    java.lang.Object
      java.lang.Enum<CreateFlag>
          org.apache.hadoop.fs.CreateFlag

All Implemented Interfaces:
  Serializable, Comparable<CreateFlag>

    @InterfaceAudience.Public
    @InterfaceStability.Evolving
    public enum CreateFlag

extends Enum<CreateFlag>

CreateFlag specifies the file create semantic. Users can combine flags like:
`EnumSet.of(CreateFlag.CREATE, CreateFlag.APPEND) ```

Use the CreateFlag as follows:

1. CREATE - to create a file if it does not exist, else throw FileAlreadyExists.
2. APPEND - to append to a file if it exists, else throw FileNotFoundException.
3. OVERWRITE - to truncate a file if it exists, else throw FileNotFoundException.
4. CREATE|APPEND - to create a file if it does not exist, else append to an existing file.
5. CREATE|OVERWRITE - to create a file if it does not exist, else overwrite an existing file.

Following combination is not valid and will result in `HadoopIllegalArgumentException`:

1. APPEND|OVERWRITE
2. CREATE|APPEND|OVERWRITE

Enum Constant Summary
`APPEND` Append to a file.
`CREATE` Create a file.
`OVERWRITE` Truncate/overwrite a file.

Method Summary
`static void` | `validate(EnumSet<CreateFlag> flag)` Validate the CreateFlag and throw exception if it is invalid
`static void` | `validate(Object path, boolean pathExists, EnumSet<CreateFlag> flag)` Validate the CreateFlag for create operation
`static CreateFlag` | `valueOf(String name)` Returns the enum constant of this type with the specified name.
`static CreateFlag[]` | `values()` Returns an array containing the constants of this enum type, in the order they are declared.

Methods inherited from class java.lang.Enum
`clone, compareTo, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Enum Constant Detail

### CREATE

    public static final CreateFlag CREATE

  Create a file. See javadoc for more description already exists

### OVERWRITE

    public static final CreateFlag OVERWRITE

  Truncate/overwrite a file. Same as POSIX O_TRUNC. See javadoc for description.

### APPEND

    public static final CreateFlag APPEND

  Append to a file. See javadoc for more description.

Method Detail

### values

    public static CreateFlag[] values()

  Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

      for (CreateFlag c : CreateFlag.values())
          System.out.println(c);

  Returns:
    an array containing the constants of this enum type, in the order they are declared

### valueOf

    public static CreateFlag valueOf(String name)

  Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)

  Parameters:
    `name` - the name of the enum constant to be returned.
  Returns:
    the enum constant with the specified name
  Throws:
    `IllegalArgumentException` - if this enum type has no constant with the specified name
    `NullPointerException` - if the argument is null

### validate

    public static void validate(EnumSet<CreateFlag> flag)

  Validate the CreateFlag and throw exception if it is invalid

  Parameters:
    `flag` - set of CreateFlag
  Throws:
    `HadoopIllegalArgumentException` - if the CreateFlag is invalid

### validate

    public static void validate(Object path,
                                boolean pathExists,
                                EnumSet<CreateFlag> flag)
                         throws IOException

  Validate the CreateFlag for create operation

  Parameters:
    `path` - Object representing the path; usually String or `Path`
    `pathExists` - pass true if the path exists in the file system
    `flag` - set of CreateFlag
  Throws:
    `IOException` - on error
    `HadoopIllegalArgumentException` - if the CreateFlag is invalid

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | ENUM CONSTANTS | FIELD | METHOD | DETAIL: ENUM CONSTANTS | FIELD | METHOD

Copyright © 2012 Apache Software Foundation. All Rights Reserved.